<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 1.2: Variables and Arithmetic Expressions</title>
<link href="sx4a.html" rev=precedes>
<link href="sx4c.html" rel=precedes>
<link href="sx4.html" rev=subdocument>
</head>
<body>
<H2>section 1.2: Variables and Arithmetic Expressions</H2>

<p>page 10
</p><p>Deep sentence:
<blockquote>Although
C compilers do not care about how a program looks,
proper indentation and spacing are critical
in making programs easy
for people to read.
We recommend writing only one statement per line,
and using blanks around operators to clarify grouping.
The position of braces is less important,
although people hold passionate beliefs.
We have chosen one of several popular styles.
Pick a style that suits you,
then use it consistently.
</blockquote>There are two things to note here.
One is that
(with one or two exceptions)
the compiler really does not care how a program looks;
it doesn't matter how it's broken into lines.
The fragments
<pre>while(i &lt; j)
	i = 2 * i;
</pre>and
<pre>while(i &lt; j) i = 2 * i;
</pre>and
<pre>while(i&lt;j)i=2*i;
</pre>and
<pre>	while(i &lt; j)
i = 2 * i;
</pre>and
<pre>while	(
i	&lt;
j	)
i	=
2	*
i	;
</pre>are all treated exactly the same way by the compiler.
</p><p>The second thing to note is that style issues
(such as how a program is laid out)
<em>are</em> important,
but they're not something to be too dogmatic about,
and there are
also
other, deeper style issues besides mere layout 
and typography.
</p><p>There is some value in having a reasonably standard style
(or a few standard styles)
for code layout.
Please don't take the authors' advice to
``pick a style that suits you''
as an invitation to invent your own brand-new style.
If
(perhaps after you've been programming in C for a while)
you have specific objections to specific facets of existing styles,
you're welcome to modify them,
but if you don't have any particular leanings,
you're probably best off copying an existing style at first.
(If you want to place your own stamp of originality
on the programs that you write,
there are better avenues for your creativity than inventing a bizarre layout;
you might instead try to make the logic easier to follow,
or the user interface easier to use,
or the code freer of bugs.)
</p><p>Deep sentence:
<blockquote>...in C,
as in many other languages,
integer division <I>truncates</I>:
any fractional part is discarded.
</blockquote>The authors say all there is to say here,
but remember it:
just when you've forgotten this sentence,
you'll wonder why something is coming out zero
when you thought it was supposed the be the quotient
of two nonzero numbers.
</p><p>page 12
</p><p>Here is more discussion on the difference between integer and 
floating-point division.
Nothing deep; just something to remember.
</p><p>page 13
</p><p>Hidden here are discriptions of some more of
<TT>printf</TT>'s ``conversion specifiers.''
<TT>%o</TT> and <TT>%x</TT> print integers, in octal (base 8) and
hexadecimal (base 16), respecively.
Since a percent sign normally tells <TT>printf</TT> to expect
an additional argument and insert its value,
you might wonder how to get <TT>printf</TT> to just print a
<TT>%</TT>.
The answer is to double it: <TT>%%</TT>.
</p><p>Also, note
(as was mentioned on page 11)
that <em>you</em> must match up the arguments to <TT>printf</TT>
with
the conversion specification;
the compiler can't (or won't) generally check them for you
or fix things up if you get them wrong.
If <TT>fahr</TT> is a float,
the code
<pre>	printf("%d\n", fahr);
</pre>will <em>not</em> work.
You might ask,
``Can't the compiler see that <TT>%d</TT> needs an integer and 
<TT>fahr</TT> is floating-point and do the conversion 
automatically,
just like in the assignments and comparisons on page 12?''
And the answer is, no.
As far as the compiler knows,
you've just passed a character string and some other arguments 
to <TT>printf</TT>;
it doesn't know that there's a connection between the arguments 
and some special characters inside the string.
This is one of the implications of the fact,
stated earlier,
that functions like <TT>printf</TT> are not special.
(Actually, some compilers or other program checkers do know 
that a function named <TT>printf</TT> is special,
and will do some extra checking for you,
but you can't count on it.)
</p><hr>
<p>
Read sequentially:
<a href="sx4a.html" rev=precedes>prev</a>
<a href="sx4c.html" rel=precedes>next</a>
<a href="sx4.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
